#ifndef GENERATED_ASN1SCC_Time_H
#define GENERATED_ASN1SCC_Time_H
/*
Code automatically generated by asn1scc tool
*/
#include "taste-extended.h"
#include "taste-types.h"
#include "asn1crt.h"

#ifdef  __cplusplus
extern "C" {
#endif



typedef struct {
    T_Int64 microseconds;
    T_Int32 usecPerSec;
} Time;

#define Time_REQUIRED_BYTES_FOR_ENCODING       12 
#define Time_REQUIRED_BITS_FOR_ENCODING        96
#define Time_REQUIRED_BYTES_FOR_ACN_ENCODING   12 
#define Time_REQUIRED_BITS_FOR_ACN_ENCODING    96
#define Time_REQUIRED_BYTES_FOR_XER_ENCODING   107

void Time_Initialize(Time* pVal);
flag Time_IsConstraintValid(const Time* val, int* pErrCode);


typedef enum {
    seconds = 0,
    milliseconds = 1,
    microseconds = 2
} Resolution;

#define Resolution_REQUIRED_BYTES_FOR_ENCODING       1 
#define Resolution_REQUIRED_BITS_FOR_ENCODING        2
#define Resolution_REQUIRED_BYTES_FOR_ACN_ENCODING   1 
#define Resolution_REQUIRED_BITS_FOR_ACN_ENCODING    2
#define Resolution_REQUIRED_BYTES_FOR_XER_ENCODING   42

void Resolution_Initialize(Resolution* pVal);
flag Resolution_IsConstraintValid(const Resolution* val, int* pErrCode);
#ifndef ERR_Resolution_unknown_enumeration_value 
#define ERR_Resolution_unknown_enumeration_value		1002  /**/
#endif
#ifndef ERR_Resolution 
#define ERR_Resolution		1001  /**/
#endif

 

/* ================= Encoding/Decoding function prototypes =================
 * These functions are placed at the end of the file to make sure all types
 * have been declared first, in case of parameterized ACN encodings
 * ========================================================================= */

flag Time_Encode(const Time* val, BitStream* pBitStrm, int* pErrCode, flag bCheckConstraints);
flag Time_Decode(Time* pVal, BitStream* pBitStrm, int* pErrCode);
flag Resolution_Encode(const Resolution* val, BitStream* pBitStrm, int* pErrCode, flag bCheckConstraints);
flag Resolution_Decode(Resolution* pVal, BitStream* pBitStrm, int* pErrCode); 


#ifdef  __cplusplus
}
#define ENUM_seconds	seconds
#define ENUM_milliseconds	milliseconds
#define ENUM_microseconds	microseconds

#endif

#endif
